*:*********************************************************************
*:
*:        Program: MANALYZE.PRG
*:
*:         System: 
*:         Author: 
*:      Copyright (c) 1991, 
*:  Last modified: 02/10/91     14:22
*:
*:  Procs & Fncts: MAKEOUT()
*:               : VIEWIT()
*:               : ALLTRIM()
*:               : H2D()
*:
*:          Calls: MAKEOUT()      (function  in MANALYZE.PRG)
*:               : VIEWIT()       (function  in MANALYZE.PRG)
*:
*:      Documented 02/12/91 at 16:17                SNAP!  version 4.00
*:*********************************************************************
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Name .........  Manalyze.prg
* Author .......  Brad Cleaver
* Purpose.......  Analyzes MAP file generated by A switch in BLINKER
* Date .........  Feb 91
* Copyright ....  Public Domain
* Usage:          MANALYZE
* Compile ....... Clipper Manalyze -m
* Link .......... Blinker fi Manalyze lib Clipper,Extend
* Notes:          Be Certain that you insert a line such as
*                 MAP = MYFILE.MAP A
*                 into your blinker .LNK file to create
*                 the map file.  This program will have to
*                 be adjusted if the layout of the MAP file
*                 changes
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


* -----------------------
* Initialize Mvars...
* -----------------------
PRIVATE mapnum, handle, tab, k_esc, mapname, outputfile, keypress
PRIVATE t,l,B,R, element
tab        =SPACE(4)
mmap       =.T.
k_esc      =27
t          =8
l          =35
B          =t+5
R          =45


DO WHILE .T.
   * -----------------------
   * Clear the screen
   * -----------------------
   SCROLL(0,0,24,79,0)
   * Crude instructions:
   @ 0,0 SAY ""
   TEXT
                              Manalyze
                              --------

      Move cursor to the MAP file you want to analyze, then tap the
      ENTER key.  Or tap ESC to cancel.


   ENDTEXT
   
   mapnum= ADIR("*.MAP")
   PRIVATE maparray[MapNum]
   ADIR("*.MAP", maparray)
   @ t-1,l-1,B+1,R+1 BOX CHR(249)
   element=ACHOICE(t,l,B,R,maparray)
   
   IF element=0
      EXIT
   ENDIF
   mapname=maparray[element]
   
   outputfile=SUBSTR(mapname,1,AT(".",mapname))+"ANA" ;
      +SPACE(12-LEN(ALLTRIM(mapname)))
   
   @ B+3,10 SAY "Map to analyze is "+mapname
   @ B+5,10 SAY "Enter Name of OutPut FIle..(Tap ESC to cancel).." GET outputfile PICTURE "@!"
   READ
   keypress=LASTKEY()
   IF keypress=k_esc
      EXIT
   ENDIF
   
   @ B+7,10 SAY "Working..."
   
   IF makeout()
      viewit()
   ENDIF
ENDDO
RETURN

* = = = = = = = = = = =
*!*********************************************************************
*!
*!       Function: MAKEOUT()
*!
*!      Called by: MANALYZE.PRG                  
*!
*!          Calls: H2D()          (function  in MANALYZE.PRG)
*!
*!    Other Files: =SUBSTR(MLINE,45,12)
*!
*!*********************************************************************
FUNCTION makeout
* = = = = = = = = = = =
PRIVATE inputfile, num_lines, xx, legend, crlf, result
crlf=CHR(13)+CHR(10)
result=.F.

BEGIN SEQUENCE
   inputfile =MEMOREAD(mapname)
   num_lines = MLCOUNT(inputfile, 65)
   * ---------------------------------------------------
   * Initialize arrays to place each line until we
   * are ready to print to file
   * ---------------------------------------------------
   PRIVATE legendword[num_lines], legendamt[num_lines]
   * ------------------------------------------
   * Put dummy value "End of Array" to simplify
   * processing later
   * ------------------------------------------
   AFILL(legendword,"EOA")
   legend=1
   
   * ----------------------------------------------------
   * Cycle through each line in the map file, ignoring
   * anything that starts with TEXT.  This is an
   * example of a line we want to process:
   * 0016EH 018C0H 01753H DRIVERS_TEXT           CODE
   * ----------------------------------------------------
   
   FOR xx = 1 TO num_lines
      MLINE=ALLTRIM(MEMOLINE(inputfile, 65, xx))
      IF .NOT. ISALPHA(MLINE) .AND. .NOT. EMPTY(MLINE)
         * ------------------------------------------
         * Parse the line into each component, and
         * use the Hex to Decimal function to
         * change the numbers .....
         * Note: Here is where you would make changes
         * if BLINKER ever changes the layout of
         * the map file.  Change the SUBSTR coordinates
         * if needed.
         * ------------------------------------------
         START =h2d(SUBSTR(MLINE,1,5))
         END   =h2d(SUBSTR(MLINE,8,5))
         length=h2d(SUBSTR(MLINE,15,5))
         owner =SUBSTR(MLINE,22,15)
         TYPE  =SUBSTR(MLINE,45,12)
         * -----------------------------------------------
         * Format our output, place into our arrays
         * -----------------------------------------------
         legendamt[legend] =length
         legendword[legend]=owner+tab+TYPE+SPACE(10-LEN(ALLTRIM(TYPE)))+;
            TRANSFORM(START,"999,999")+tab+TRANSFORM(END,"999,999")+tab+;
            TRANSFORM(END-START,"999,999")
         
         legend=legend+1
      ELSE
         * ------------------------------------
         * Must be alpha, don't process, or
         * process in a way to be determined
         * later ...
         * ------------------------------------
      ENDIF
   NEXT
   
   * -----------------------------------------------------------------
   * Okay, array is filled with our stats, open a file
   * and fill it...
   * -----------------------------------------------------------------
   handle = FCREATE(outputfile)
   IF FERROR() <> 0
      ? outputfile+" could not be opened.  Error number is", FERROR()
      BREAK
   ENDIF
   * ---------------------------------
   *  Move pointer to end of file
   *  Write contents to file
   * ---------------------------------
   FSEEK(handle, 0,2)
   
   * Header...
   FWRITE(handle,+crlf)
   FWRITE(handle,"                            ----- ADDRESS -----           "+crlf)
   FWRITE(handle,"Module             Type        START        END     LENGTH"+crlf)
   
   * ---------------------------------------------------------
   * The last value of END happens to also be our EXE file
   * size...Use it to base our percentages...
   * ---------------------------------------------------------
   tot=END
   zz=1
   DO WHILE legendword[zz]<>"EOA"
      * Data...
      FWRITE(handle,legendword[zz]+tab+TRANSFORM(legendamt[zz]/tot*100,"%999.99")+crlf)
      zz=zz+1
   ENDDO
   
   * ------------------------
   * Close the file...
   * ------------------------
   FCLOSE(handle)
   IF FERROR() <> 0
      ? "File close unsuccessful.  Error number is", FERROR()
      BREAK
   ENDIF
   
   result=.T.
END sequence
RETURN(result)


* = = = = = = = = = = =
*!*********************************************************************
*!
*!       Function: VIEWIT()
*!
*!      Called by: MANALYZE.PRG                  
*!
*!*********************************************************************
FUNCTION viewit
* = = = = = = = = = = =
SCROLL(0,0,24,79,0)
@ 0,0,22,79 BOX CHR(249)
@ 23,0 SAY "Tap ESC when finished viewing"
MEMOEDIT(MEMOREAD(outputfile),1,1,21,78,.F.)
RETURN[]



* = = = = = = = = = = =
*!*********************************************************************
*!
*!       Function: ALLTRIM()
*!
*!*********************************************************************
FUNCTION ALLTRIM
* = = = = = = = = = = =
PARAMETER string
RETURN(LTRIM(TRIM(string)))

* = = = = = = = = = = =
*!*********************************************************************
*!
*!       Function: H2D()
*!
*!      Called by: MAKEOUT()      (function  in MANALYZE.PRG)
*!
*!*********************************************************************
FUNCTION h2d
* = = = = = = = = = = =
PARAMETERS whatnum
PRIVATE hexstring, result, whatlength, primer
hexstring="123456789ABCDEF"
whatlength=LEN(whatnum)
result=0
primer=1
FOR I = 1 TO whatlength
   result=result+AT(SUBSTR(whatnum,whatlength-I+1,1),hexstring)*primer
   *AT(SUBSTR(WhatNum,i,1),HexString)
   primer=primer*16
NEXT i
RETURN(result)

* Here is a sample of the text file this routine reads
* ----------------------------------------------------
* 0016EH 018C0H 01753H DRIVERS_TEXT           CODE
* ----------------------------------------------------


*: EOF: MANALYZE.PRG
